'==============================================================================
' File: 3d-DEMO.BAS
' Desc: Program to demonstrate some of the PB-XLIB functions
'------------------------------------------------------------------------------

$DIM      ALL           '
$LIB      ALL OFF       '
$ERROR    ALL OFF       '
$STACK    4096          '
$COMPILE  EXE           '
$OPTIMIZE SIZE          ' Optimize for smaller code
$DYNAMIC

DEFINT    A-Z           '

'------------------------------------------------------------------------------

$INCLUDE "xlib.pbi"
$LINK    "xlib.pbl"

'------------------------------------------------------------------------------

DECLARE SUB Main()
DECLARE SUB GetMode()
DECLARE SUB Initialize()
DECLARE SUB xGet(BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2, string)

'------------------------------------------------------------------------------

DECLARE SUB LookingUp    (CX, CY)
DECLARE SUB LookingDown  (CX, CY)
DECLARE SUB LookingLeft  (CX, CY)
DECLARE SUB LookingRight (CX, CY)
DECLARE SUB MoveForward  (CX, CY, ByVal Di)

'------------------------------------------------------------------------------

DIM Level(30)   AS SHARED STRING

DIM Floor   AS SHARED STRING,_
    Ceiling AS SHARED STRING,_
    RWall1  AS SHARED STRING,_
    LWall1  AS SHARED STRING,_
    FWall1  AS SHARED STRING,_
    RWall2  AS SHARED STRING,_
    LWall2  AS SHARED STRING,_
    FWall2  AS SHARED STRING,_
    RWall3  AS SHARED STRING,_
    LWall3  AS SHARED STRING,_
    FWall3  AS SHARED STRING,_
    RWall4  AS SHARED STRING,_
    LWall4  AS SHARED STRING,_
    FWall4  AS SHARED STRING

DIM Pal     AS SHARED STRING '* 768

DIM CX AS SHARED INTEGER, CY AS SHARED INTEGER,_
    Mx AS SHARED INTEGER, My AS SHARED INTEGER,_
    DI AS SHARED INTEGER, ReDraw AS SHARED INTEGER

DIM vScreen AS SHARED STRING,_
    Blank   AS SHARED STRING

DIM I       AS SHARED STRING,_
    Mode    AS SHARED STRING

'==============================================================================

Initialize
Main

'------------------------------------------------

SUB Main

  DO
    WHILE NOT INSTAT: WEND: I$ = INKEY$

    SELECT CASE i$

      CASE CHR$(0) + CHR$(72)          ' Move Forward
        Mx = CX
        My = CY
        MoveForward CX, CY, Di
        IF Mx = CX AND My = CY THEN
          '
        ELSE
          Redraw = 1
        END IF

      CASE CHR$(0) + CHR$(75)          ' Turn CounterClockwise
        Di = Di - 1
        IF Di = 0 THEN Di = 4
        Redraw = 1

      CASE CHR$(0) + CHR$(77)          ' Turn Clockwise
        Di = Di + 1
        IF Di = 5 THEN Di = 1
        Redraw = 1

    END SELECT

    IF Redraw = 1 THEN

      SELECT CASE Di
        CASE 1 : LookingUp CX, CY
        CASE 2 : LookingRight CX, CY
        CASE 3 : LookingDown CX, CY
        CASE 4 : LookingLeft CX, CY
      END SELECT

      Redraw = 0

    END IF

  LOOP UNTIL i$ = CHR$(27)

  AllDone:

  xTextMode
  END

END SUB

'******************************************************************************

'----------------------------------------------------------
'- LookingUp
'----------------------------------------------------------

SUB LookingUp (CX AS INTEGER, CY AS INTEGER)

  vScreen = Blank               ' Blank the virtual screen
  vPut VScreen, 0, 0,  Ceiling  ' Copy ceiling to vScreen
  vPut VScreen, 0, 55, Floor    ' Copy floor to vScreen

  '--------------------------------------------------------

  IF CX - 3 > 0 THEN
    IF ASC(MID$(Level$(CX - 3), CY - 1, 1)) <> 32 THEN vTPut vScreen, 11,  27, LWall4
    IF ASC(MID$(Level$(CX - 3), CY + 1, 1)) <> 32 THEN vTPut vScreen, 105, 27, RWall4
    IF ASC(MID$(Level$(CX - 3), CY, 1)) <> 32     THEN vTPut vScreen, 64,  27, FWall4
  END IF

  '--------------------------------------------------------

  IF CX - 2 > 0 THEN
    IF ASC(MID$(Level$(CX - 2), CY - 1, 1)) <> 32 THEN vTPut vScreen, 0,   20, LWall3
    IF ASC(MID$(Level$(CX - 2), CY + 1, 1)) <> 32 THEN vTPut vScreen, 113, 20, RWall3
    IF ASC(MID$(Level$(CX - 2), CY, 1)) <> 32     THEN vTPut vScreen, 47,  20, FWall3
  END IF

  '--------------------------------------------------------

  IF CX - 1 > 0 THEN
    IF ASC(MID$(Level$(CX - 1), CY - 1, 1)) <> 32 THEN vTPut vScreen, 0,   9, LWall2
    IF ASC(MID$(Level$(CX - 1), CY + 1, 1)) <> 32 THEN vTPut vScreen, 128, 9, RWall2
    IF ASC(MID$(Level$(CX - 1), CY, 1)) <> 32     THEN vTPut vScreen, 23,  8, FWall1
  END IF

  '--------------------------------------------------------

  IF ASC(MID$(Level$(CX), CY - 1, 1)) <> 32 THEN vTPut vScreen, 0,   1, LWall1
  IF ASC(MID$(Level$(CX), CY + 1, 1)) <> 32 THEN vTPut vScreen, 152, 0, RWall1

  xDrawBitMap STRSEG(vScreen), STRPTR(vScreen)+4, 0, 0, 177, 120

END SUB

'----------------------------------------------------------
' LookingDown
'----------------------------------------------------------

SUB LookingDown (CX AS INTEGER, CY AS INTEGER)

  'SHARED Mode$, vScreen()

  vScreen = Blank               ' Blank the virtual screen
  VPut VScreen, 0, 0,  Ceiling  ' Copy ceiling to vScreen
  VPut VScreen, 0, 55, Floor    ' Copy floor to vScreen

  '--------------------------------------------------------

  IF CX + 3 < 31 THEN
    IF ASC(MID$(Level$(CX + 3), CY + 1, 1)) <> 32 THEN vTPut VScreen, 11, 27,  LWall4
    IF ASC(MID$(Level$(CX + 3), CY - 1, 1)) <> 32 THEN vTPut VScreen, 105, 27, RWall4
    IF ASC(MID$(Level$(CX + 3), CY, 1)) <> 32     THEN vTPut VScreen, 64, 27,  FWall4
  END IF

  '--------------------------------------------------------

  IF CX + 2 < 31 THEN
     IF ASC(MID$(Level$(CX + 2), CY + 1, 1)) <> 32 THEN vTPut VScreen, 0, 20,   LWall3
     IF ASC(MID$(Level$(CX + 2), CY - 1, 1)) <> 32 THEN vTPut VScreen, 113, 20, RWall3
     IF ASC(MID$(Level$(CX + 2), CY, 1)) <> 32     THEN vTPut VScreen, 48, 20,  FWall3
  END IF

  '--------------------------------------------------------

  IF CX + 1 < 31 THEN
     IF ASC(MID$(Level$(CX + 1), CY + 1, 1)) <> 32 THEN vTPut VScreen, 0, 9,   LWall2
     IF ASC(MID$(Level$(CX + 1), CY - 1, 1)) <> 32 THEN vTPut VScreen, 128, 9, RWall2
     IF ASC(MID$(Level$(CX + 1), CY, 1)) <> 32     THEN vTPut VScreen, 23, 8,  FWall1
  END IF

  '--------------------------------------------------------

  IF ASC(MID$(Level$(CX), CY + 1, 1)) <> 32 THEN vTPut VScreen, 0, 1,   LWall1
  IF ASC(MID$(Level$(CX), CY - 1, 1)) <> 32 THEN vTPut VScreen, 152, 0, RWall1

  xDrawBitMap STRSEG(vScreen), STRPTR(vScreen)+4, 0, 0, 177, 120

END SUB

'----------------------------------------------------------
'- LookingLeft
'----------------------------------------------------------

SUB LookingLeft (CX AS INTEGER, CY AS INTEGER)

  vScreen = Blank               ' Blank the virtual screen
  VPut VScreen, 0, 0,  Ceiling  ' Copy ceiling to vScreen
  VPut VScreen, 0, 55, Floor    ' Copy floor to vScreen

  '--------------------------------------------------------

    IF CY - 3 > 0 THEN
       IF ASC(MID$(Level$(CX + 1), CY - 3, 1)) <> 32 THEN vTPut vScreen, 11, 27, LWall4
       IF ASC(MID$(Level$(CX - 1), CY - 3, 1)) <> 32 THEN vTPut vScreen, 105, 27, RWall4
       IF ASC(MID$(Level$(CX), CY - 3, 1)) <> 32     THEN vTPut vScreen, 64, 27, FWall4
    END IF

  '--------------------------------------------------------

    IF CY - 2 > 0 THEN
       IF ASC(MID$(Level$(CX + 1), CY - 2, 1)) <> 32 THEN vTPut vScreen, 0, 20, LWall3
       IF ASC(MID$(Level$(CX - 1), CY - 2, 1)) <> 32 THEN vTPut vScreen, 113, 20, RWall3
       IF ASC(MID$(Level$(CX), CY - 2, 1)) <> 32     THEN vTPut vScreen, 48, 20, FWall3
    END IF

  '--------------------------------------------------------

    IF CY - 1 > 0 THEN
       IF ASC(MID$(Level$(CX + 1), CY - 1, 1)) <> 32 THEN vTPut vScreen, 0, 9, LWall2
       IF ASC(MID$(Level$(CX - 1), CY - 1, 1)) <> 32 THEN vTPut vScreen, 128, 9, RWall2
       IF ASC(MID$(Level$(CX), CY - 1, 1)) <> 32     THEN vTPut vScreen, 23, 8, FWall1
    END IF

  '--------------------------------------------------------

    IF ASC(MID$(Level$(CX + 1), CY, 1)) <> 32 THEN vTPut vScreen, 0, 1, LWall1
    IF ASC(MID$(Level$(CX - 1), CY, 1)) <> 32 THEN vTPut vScreen, 152, 0, RWall1

  xDrawBitMap STRSEG(vScreen), STRPTR(vScreen)+4, 0, 0, 177, 120

END SUB

'----------------------------------------------------------
'- LookingRight
'----------------------------------------------------------

SUB LookingRight (CX AS INTEGER, CY AS INTEGER)

  vScreen = Blank               ' Blank the virtual screen
  VPut VScreen, 0, 0,  Ceiling  ' Copy ceiling to vScreen
  VPut VScreen, 0, 55, Floor    ' Copy floor to vScreen

  '--------------------------------------------------------

    IF CY + 3 < 31 THEN
       IF ASC(MID$(Level$(CX - 1), CY + 3, 1)) <> 32 THEN vTPut vScreen, 11, 27, LWall4
       IF ASC(MID$(Level$(CX + 1), CY + 3, 1)) <> 32 THEN vTPut vScreen, 105, 27, RWall4
       IF ASC(MID$(Level$(CX), CY + 3, 1)) <> 32     THEN vTPut vScreen, 64, 27, FWall4
    END IF

  '--------------------------------------------------------

    IF CY + 2 < 31 THEN
       IF ASC(MID$(Level$(CX - 1), CY + 2, 1)) <> 32 THEN vTPut vScreen, 0, 20, LWall3
       IF ASC(MID$(Level$(CX + 1), CY + 2, 1)) <> 32 THEN vTPut vScreen, 113, 20, RWall3
       IF ASC(MID$(Level$(CX), CY + 2, 1)) <> 32     THEN vTPut vScreen, 48, 20, FWall3
    END IF

  '--------------------------------------------------------

    IF CY + 1 < 31 THEN
       IF ASC(MID$(Level$(CX - 1), CY + 1, 1)) <> 32 THEN vTPut vScreen, 0, 9, LWall2
       IF ASC(MID$(Level$(CX + 1), CY + 1, 1)) <> 32 THEN vTPut vScreen, 128, 9, RWall2
       IF ASC(MID$(Level$(CX), CY + 1, 1)) <> 32     THEN vTPut vScreen, 23, 8, FWall1
    END IF

  '--------------------------------------------------------

    IF ASC(MID$(Level$(CX - 1), CY, 1)) <> 32 THEN vTPut vScreen, 0, 1, LWall1
    IF ASC(MID$(Level$(CX + 1), CY, 1)) <> 32 THEN vTPut vScreen, 152, 0, RWall1

  xDrawBitMap STRSEG(vScreen), STRPTR(vScreen)+4, 0, 0, 177, 120

END SUB

'----------------------------------------------------------
' MoveForward
'----------------------------------------------------------

SUB MoveForward (CX AS INTEGER, CY AS INTEGER, ByVal Di AS INTEGER)

  DIM NewX AS INTEGER, NewY AS INTEGER

  NewX = CX
  NewY = CY

  SELECT CASE Di

    CASE 1
      NewX = NewX - 1
      IF NewX < 1 THEN
         NewX = 1
      END IF

      IF ASC(MID$(Level$(NewX), NewY, 1)) <> 32 THEN
         NewX = CX
         NewY = CY
      END IF

    CASE 2
      NewY = NewY + 1
      IF NewY > 30 THEN
         NewY = 30
      END IF

      IF ASC(MID$(Level$(NewX), NewY, 1)) <> 32 THEN
         NewX = CX
         NewY = CY
      END IF

    CASE 3
      NewX = NewX + 1
      IF NewX > 30 THEN
         NewX = 30
      END IF

      IF ASC(MID$(Level$(NewX), NewY, 1)) <> 32 THEN
         NewX = CX
         NewY = CY
      END IF

    CASE 4
      NewY = NewY - 1
      IF NewY < 1 THEN
         NewY = 1
      END IF

      IF ASC(MID$(Level$(NewX), NewY, 1)) <> 32 THEN
         NewX = CX
         NewY = CY
      END IF

  END SELECT

  CX = NewX
  CY = NewY

END SUB

'----------------------------------------------------------
'- Initialize
'----------------------------------------------------------

SUB Initialize

  DIM X1 AS INTEGER, Y1 AS INTEGER,_
      X2 AS INTEGER, Y2 AS INTEGER

  GetMode

  Level$(1)  = ""
  Level$(2)  = "              "
  Level$(3)  = "                         "
  Level$(4)  = "                          "
  Level$(5)  = "                 "
  Level$(6)  = "                   "
  Level$(7)  = "           "
  Level$(8)  = "                           "
  Level$(9)  = "  "
  Level$(10) = "  "
  Level$(11) = "                           "
  Level$(12) = "     "
  Level$(13) = "                         "
  Level$(14) = "                          "
  Level$(15) = "                 "
  Level$(16) = "                   "
  Level$(17) = "           "
  Level$(18) = "                           "
  Level$(19) = "  "
  Level$(20) = "  "
  Level$(21) = "                           "
  Level$(22) = "     "
  Level$(23) = "                         "
  Level$(24) = "                          "
  Level$(25) = "                 "
  Level$(26) = "                   "
  Level$(27) = "           "
  Level$(28) = "                           "
  Level$(29) = "                           "
  Level$(30) = ""

  '-- The Floor and Ceiling -------------

  LoadBsFile "FLOOR.DAT", Floor
  LoadBsFile "Ceiling.dat", Ceiling

  '-- 1st Walls -------------------------

  LoadBsFile "RWALL1.DAT", rWall1
  LoadBsFile "LWALL1.DAT", lWall1
  LoadBsFile "FWALL1.DAT", fWall1

  '-- The 2nd Walls ---------------------

  LoadBsFile "RWALL2.DAT", rWall2
  LoadBsFile "LWALL2.DAT", lWall2
  LoadBsFile "FWALL2.DAT", fWall2

  '-- 3rd Walls -------------------------

  LoadBsFile "RWALL3.DAT", rWall3
  LoadBsFile "LWALL3.DAT", lWall3
  LoadBsFile "FWALL3.DAT", fWall3

  '-- 4th Front Wall --------------------

  LoadBsFile "RWALL4.DAT", rWall4
  LoadBsFile "LWALL4.DAT", lWall4
  LoadBsFile "FWALL4.DAT", fWall4

  '--------------------------------------

  LoadBsPal "3-D.PLT", Pal

  SELECT CASE VAL(Mode$)
    CASE 1 : xSetModeX %xMode320x200
    CASE 2 : xSetModeX %xMode320x240
    CASE 3 : xSetModeX %xMode320x400
    CASE 4 : xSetModeX %xMode360x480
  END SELECT

  xSetPal StrSeg(Pal), StrPtr(Pal), 0, LEN(Pal)\3

  X1 = 0
  Y1 = 0
  X2 = 176
  Y2 = 119

  xRectFill X1, Y1, X2, Y2, 255, VisiblePageOffs
  xGet X1, Y1, X2, Y2, Blank
  vScreen = Blank

  CX = 15
  CY = 14
  Di = 1

  SELECT CASE Di
    CASE 1 : LookingUp CX, CY
    CASE 2 : LookingRight CX, CY
    CASE 3 : LookingDown CX, CY
    CASE 4 : LookingLeft CX, CY
  END SELECT

END SUB

'----------------------------------------------------------
'- GetMode
'----------------------------------------------------------

SUB GetMode

  CLS

  LOCATE 1, 1
  PRINT "Select Mode To Run:"

  LOCATE 3, 1
  PRINT "   1)  320x200"
  PRINT "   2)  320x240"
  PRINT "   3)  320x400"
  PRINT "   4)  360x480"

  WHILE NOT INSTAT : WEND
  I$ = INKEY$
  IF I$ = CHR$(27) THEN GOTO AllDone
  Mode$ = i$

END SUB

'----------------------------------------------------------
'- xGet
'----------------------------------------------------------

SUB xGet (BYVAL X1 AS INTEGER, BYVAL Y1 AS INTEGER,_
          BYVAL X2 AS INTEGER, BYVAL Y2 AS INTEGER, Image AS STRING) PUBLIC

  DIM W  AS INTEGER, H  AS INTEGER

  IF X2 < X1 THEN
    W  = X1
    X1 = X2
    X2 = W
  END IF

  IF Y2 < Y1 THEN
    W  = Y1
    Y1 = Y2
    Y2 = W
  END IF

  W = X2 - X1 + 1
  H = Y2 - Y1 + 1

  Image = STRING$( (W * H)+4, 0 )
  xGetLbm x1, y1, W, H, Image

END SUB
