'------------------------------------------------------------------------------
'
' File: XLIB.PBI
' Desc: XLIB - include file
'
'------------------------------------------------------------------------------

$INCLUDE "xtypes.pbi"
$INCLUDE "xpal.pbi"
$INCLUDE "xline.pbi"
$INCLUDE "xmouse.pbi"
$INCLUDE "xcircle.pbi"
$INCLUDE "xbezier.pbi"
$INCLUDE "utils.pbi"

'-- Constants -----------------------------------

%xMode320x200 = 0
%xMode320x400 = 1
%xMode360x200 = 2
%xMode360x400 = 3
%xMode320x240 = 4
%xMode320x480 = 5
%xMode360x240 = 6
%xMode360x480 = 7

%xMode360x360 = 8
%xMode376x282 = 9
%xMode376x308 = 10
%xMode376x564 = 11
%xMode256x400 = 12
%xMode256x480 = 13

%Backward     = 0
%Forward      = 1

%xModeInvalid = -1
%Error        =  1
%Ok           =  0

'-- FUNCTIONS -----------------------------------------------------------------

DECLARE FUNCTION xSetMode% ALIAS "x_set_mode" (ByVal Mode, ByVal MaxX, ByVal MaxY, ByVal Pages)
DECLARE FUNCTION xSetModeX ALIAS "x_set_modex" (ByVal Mode)
DECLARE SUB xTextMode ALIAS "x_text_mode" ()

'------------------------------------------------

DECLARE SUB xBox(ByVal X, ByVal Y, ByVal W, ByVal H,_
                 ByVal bColor?, ByVal zPage??)

DECLARE SUB xFilledBox(ByVal X, ByVal Y, ByVal W, ByVal H,_
                       ByVal bColor?, ByVal iColor?, ByVal zPage??)

DECLARE SUB xRectFill ALIAS "x_rect_fill" (ByVal x1, ByVal y1, ByVal x2, ByVal y2, ByVal Colr, ByVal offs??)

DECLARE SUB xSetPoint ALIAS "x_put_pix" (ByVal x, ByVal y, ByVal Colr, ByVal Offs??)
DECLARE FUNCTION xGetPoint ALIAS "x_get_pix" (ByVal x, ByVal y, ByVal Offs??)

DECLARE SUB xInstallVsyncHandler ALIAS "x_install_vsync_handler" (ByVal x)
DECLARE SUB xRemoveVsyncHandler  ALIAS "x_remove_vsync_handler" ()

'----- Text display routines --------------------
 
DECLARE SUB xTextInit ALIAS "x_text_init" ()
DECLARE SUB xSetFont  ALIAS "x_set_font" (ByVal TheFont)
DECLARE SUB xRegisterUserFont ALIAS "x_register_userfont" (any)

DECLARE SUB gPrintC (ByVal Char, ByVal X, ByVal Y, ByVal fColor, ByVal bColor)
DECLARE FUNCTION xCharPut ALIAS "x_char_put" (ByVal Char, ByVal X, ByVal Y, ByVal fColor, ByVal Offset??)
DECLARE FUNCTION xGetCharWidth ALIAS "x_get_char_width" (ByVal Char)

DECLARE SUB xPrintStr  ALIAS "x_print_str"  (string, ByVal MaxLen, ByVal X, ByVal Y, ByVal fColor, ByVal bColor)
DECLARE SUB xTPrintStr ALIAS "x_tprint_str" (string, ByVal MaxLen, ByVal X, ByVal Y, ByVal fColor)

DECLARE SUB xPrint(Text$, ByVal X, ByVal Y, ByVal fColor)
DECLARE SUB xBgPrint (Text$, ByVal X, ByVal Y, ByVal fColor, ByVal bColor)
DECLARE SUB xPrintf(Text$, ByVal X, ByVal Y, ByVal fColor, ByVal PageOffs)
DECLARE SUB xPrintP(Text$, ByVal X, ByVal Y, ByVal fColor, ByVal Page)

DECLARE FUNCTION GetKey%()
DECLARE FUNCTION MidByte(string, ByVal Position)

'------------------------------------------------

DECLARE SUB xSetSplitScreen  ALIAS "x_set_splitscreen"  (ByVal X)
DECLARE SUB xShowSplitScreen ALIAS "x_show_splitscreen" ()
DECLARE SUB xHideSplitScreen ALIAS "x_hide_splitscreen" ()
DECLARE SUB xAdjustSplitScreen ALIAS "x_adjust_splitscreen" (ByVal X)
DECLARE SUB xSetDoubleBuffer ALIAS "x_set_doublebuffer" (ByVal X)

'------------------------------------------------

DECLARE SUB xSetViewPort     ALIAS "x_set_start_addr"   (ByVal zPage, ByVal x, ByVal y)
DECLARE SUB xSetActivePage   ALIAS "x_set_active_page"  (ByVal zPage)
DECLARE SUB xSetDisplayPage  ALIAS "x_set_display_page" (ByVal zPage)
DECLARE SUB xClearVgaScreen  ALIAS "x_clear_vga_screen" (ByVal zColor)
DECLARE SUB xCopyPage        ALIAS "x_copy_page"        (ByVal Srce, ByVal Dest)
DECLARE SUB xCopyBitMap      ALIAS "x_copy_bitmap"      (ByVal SrcePage, ByVal  X1, ByVal  Y1, ByVal X2, ByVal Y2,_
                                                         ByVal DestPage, ByVal dX1, ByVal dY1)
DECLARE SUB xTDrawBitMap     ALIAS "x_tdraw_bitmap"     (SEG Image AS ANY, ByVal x, ByVal y, ByVal w, ByVal h)

'------------------------------------------------

DECLARE SUB xCelLoad(FileName$, zCel AS TCel)
DECLARE SUB xCelTDraw ALIAS "x_cel_tdraw" (any)

'------------------------------------------------

DECLARE SUB vPut  (Dest AS ANY, ByVal X, ByVal Y, Srce AS ANY)
DECLARE SUB vPutO (Dest AS ANY, ByVal X, ByVal Y, Srce AS ANY, ByVal Offs??)

DECLARE SUB vTPut (Dest AS ANY, ByVal X, ByVal Y, Srce AS ANY)
DECLARE SUB vTPutO(Dest AS ANY, ByVal X, ByVal Y, Srce AS ANY, ByVal Offs??)

DECLARE SUB xGetLbm ALIAS "x_get_lbm" (ByVal X1, ByVal Y1, ByVal X2, ByVal Y2, string)
DECLARE SUB xPutLbm(ByVal X1, ByVal Y1, string)

DECLARE SUB xSetPal ALIAS "x_put_pal_raw" (ByVal zSeg, ByVal zOffs, ByVal f, ByVal n)

DECLARE SUB xDrawBitMap ALIAS "x_draw_bitmap" (ByVal zSeg, ByVal zOffs, ByVal x, ByVal y, ByVal w, ByVal h)

DECLARE SUB LoadBsPal(zFile$, zBuff$)
DECLARE SUB LoadBsFile(zFile$, zBuff$)
DECLARE FUNCTION Width4(ByVal W) AS BYTE

'------------------------------------------------------------------------------

DIM    VisiblePageOffs         AS WORD,_
       SplitScrnOffs           AS WORD,_
       ScrnPhysicalHeight      AS WORD,_
       ScrnLogicalPixelWidth   AS WORD,_
       ScrnPhysicalPixelWidth  AS WORD,_
       CharHeight              AS BYTE,_
       CurrentPage             AS WORD,_
       CurrentSegment          AS WORD,_
       PageAddr(0:3)           AS WORD

PUBLIC VisiblePageOffs, SplitScrnOffs, ScrnPhysicalHeight,_
       ScrnLogicalPixelWidth, ScrnPhysicalPixelWidth, CharHeight,_
       CurrentPage, CurrentSegment, PageAddr()
